



#######################################################################################
# Suzi Project script
#              :
# : suzi@ircworld.ru
# : http://xirc.ru/plugins/forum/forum_viewforum.php?15
# -
#  : http://www.IRCWorld.ru & http://www.xIRC.ru
#######################################################################################

package require Tcl 	8.4
package require http	2

namespace eval kurs {

# ---------------------------------------------------------------------------
#  
# ---------------------------------------------------------------------------
	#    , ,   

	variable author			"Buster <virfx@mail.ru>"
	variable version		"01.00"
	variable date			"01-MAY-2006"

	#     
	variable unamespace		[string range [namespace current] 2 end]

	#     (   )
	variable pubprefix 		{!}
	variable pubflag			{-|-}

	# pubcmd:_ "1 2 ..."
	#     ,      
	variable pub:kurs		"$unamespace "

	#    ,   
	variable msgprefix		{!}
	variable msgflag			{-|-}
	#       ,      
	# ( --  )
	variable msg:kurs		${pub:kurs}

	#variable dccprefix		{}
	#variable dccflag			{n|-}
	#variable dcc:widpudate "cityidupdate ciupd"

	#      ,      
	#     variable [pub|msg]:handler "string ..."

	#      
	#  $unick, $uhost, $uchan
	#  tcl ,    id 
	#  .
	variable requserid		{$uhost}
	
	#        id
	variable maxreqperuser	1

	#     
	variable maxrequests	10

	#   ,       , 
	#  
	variable pause			30
	
	#  -
	#   "proxyhost.dom:proxyport"   ,  -
	#  
	variable proxy 			{}

	#   ,   "" --  
	# ,         --  
	#  "no"        
	#         
	# (      ,     )
	variable flagactas		"no"
	
	#   ,   /   
	#          
	#          -- "nodream"
	#      

	variable chflag			"$flagactas$unamespace"

	setudef  flag 			$chflag

# ---------------------------------------------------------------------------
#    
# ---------------------------------------------------------------------------
	#    --     
	#     
	variable logrequests	{'$unick', '$uhost', '$handle', '$uchan', '$ustr'}
	
	#     ,   -- 
	#  $uchan & $unick
	variable pubsend		{PRIVMSG $uchan :}

	#     ,   -- 
	#   $unick ($uchan == $unick)
	variable msgsend		{PRIVMSG $unick :}
	
	#    / 
	#  $unick
	variable errsend		{NOTICE $unick :$unick, }

	#      
	variable maxredir		1
	
	#    ,   20 
	variable timeout		60000

	#    
	variable err_ok			{}

	#     ,     
	#       
	variable err_fail		{     .  .      -.}

	#     
	variable err_queue_full	{           .   .}
	
	#       id
	variable err_queue_id	{    .}
	
	#          
	#   $timewait --  ,   
	#   
	variable err_queue_time {   .       $timewait .}
	
# ---------------------------------------------------------------------------
#  ,    
# ---------------------------------------------------------------------------
	# ,     
	variable 		fetchurl		"http://www.phnet.ru"

	#  
	variable 		reqqueue
	array unset 		reqqueue

	#  
	variable 		laststamp
	array unset		laststamp 

	variable 		cityid
	array unset		cityid 

	variable		updinprogress	0

	variable		updatetimeout	60000

	#variable		cidbasename		"$unamespace.dbi"
	#  : 1= 0=
	variable		useurl		1
	
	#   
	variable		maxres		3

#
	proc msg:kurs { unick uhost handle str } {
		pub:kurs $unick $uhost $handle $unick $str
		return
	}

	proc pub:kurs { unick uhost handle uchan str } {

		variable requserid
		variable fetchurl
		variable chflag
		variable flagactas
		variable errsend
		variable cityid		
		variable pubprefix
		variable unamespace

		set id 	 [subst -nocommands $requserid]
		set prefix [subst -nocommands $errsend]

		if { $unick ne $uchan } {
			if { ![channel get $uchan $chflag] ^ $flagactas eq "no" } {
				return
			}
		}

		set why  [queue_isfreefor $id]
		
		if { $why != "" } {
			lput puthelp $why $prefix
			return
		}

		set ustr [string toupper $str]

#		putlog "$ustr $cidx"

		variable logrequests

		if { $logrequests ne "" } {
			set logstr [subst -nocommands $logrequests]
			variable unamespace
			lput putlog $logstr "$unamespace: "
		}

		::http::config -urlencoding cp1251

		variable fetchurl		
		
		if { [queue_add "$fetchurl/rates/index.asp?type=1&printmode=1" $id "[namespace current]::dream:parser" [list $unick $uhost $uchan $ustr]] } {
			variable err_ok
			if { $err_ok ne "" } {
				lput puthelp "$err_ok.  '$ustr'" $prefix
			}
		} else {
			variable err_fail
			if { $err_fail ne "" } {
				lput puthelp $err_fail $prefix
			}
		}

		return
	}

	proc dream:parser { errid errstr body extra } {
		upvar $errid lerrid $errstr lerrstr $body lbody $extra lextra

		variable err_fail

		variable pubsend
		variable msgsend
		variable errsend
		variable useurl
		variable maxres

		foreach { unick uhost uchan ustr } $lextra { break }

		if { $lerrid ne {ok} } {
			lput putserv [subst -nocommands $err_fail] [subst -nocommands $errsend]
			return
		}

		if { $uchan eq $unick } {
			set prefix [subst -nocommands $msgsend]
		} else {
			set prefix [subst -nocommands $pubsend]
		}

		set str [encoding convertfrom cp1251 $lbody]
		
		
		#set fsuccess 0
		
		set add ""
		foreach line [split $str \n] {
			if { [regexp -nocase -- {class=\"rate1\"\ title=\".*?\">(.*?)</a>.*?class=\"rate1\"\ title=\".*?\">(.*?)</a></TD><TD>(.*?)</TD><TD>(.*?)</TD>} $line gr name name1 div index]} {
				regsub -all -- <b> $name {} name
				regsub -all -- </b> $name {} name
				set index [expr {$index / $div}]
				if { $ustr == "" } {
					append names "$add\0035$name\003"
					set add "|"
				} else {
					if {[string equal $ustr $name]} {break}	
				}
			}
		}
		
		if { $ustr == "" } {
			lput putserv "\00302: \00312! <[string toupper $names]>\003" $prefix
			return	
		}
		if { [string match $ustr $name] && $index != "" } {
			lput putserv "\0032  \0034 \0032   \00312$name1\0032  - \0033\002\002$index .\003" $prefix
			return
		} else {
			lput putserv "\0032     $ustr...\003" $prefix
			return
		}
		
		return
	}

# ---------------------------------------------------------------------------
#
# ---------------------------------------------------------------------------

	proc lput { cmd str { prefix {} } {maxchunk 400} } {
		set plen 	[string length $prefix]
		set	slen    [string length $str]
		set sidx	0
		
		while { $slen != 0 } {
			set nsl [expr { [expr { $slen + $plen }] < $maxchunk ? $slen : [ expr { $maxchunk - $plen } ] } ]
			
			$cmd $prefix[string range $str $sidx [expr { $sidx + $nsl - 1} ] ]
		
			incr slen -$nsl
			incr sidx  $nsl
		}
		
		return
	}

	proc queue_isfreefor { { id {} } } {

		variable reqqueue
		variable maxreqperuser
		variable maxrequests
		variable laststamp
		variable pause

		variable err_queue_full	
		variable err_queue_id
		variable err_queue_time 

		if { [info exists laststamp(stamp,$id)] } {
			set timewait [expr { $laststamp(stamp,$id) + $pause - [unixtime]}]

			if { $timewait > 0 } {
				return [subst -nocommands $err_queue_time]
			}			
		}

		if { [llength [array names reqqueue -glob "*,$id"]] >= $maxreqperuser } {
			return $err_queue_id
		}

		if { [llength [array names reqqueue]] >= $maxrequests } { 
			return $err_queue_full
		}
		
		return
	}

	proc queue_add { newurl id parser extra {redir 0} } {
		variable reqqueue
		variable proxy
		variable timeout
		variable laststamp

		::http::config -proxyfilter "[namespace current]::queue_proxy"
		
		if { ! [catch {
			set token [::http::geturl $newurl -command "[namespace current]::queue_done" -binary true -timeout $timeout]
			} errid] } {
					
			set reqqueue($token,$id) [list $parser $extra $redir]		
#			lput putlog "$token,$id"
			set laststamp(stamp,$id) [unixtime]

		} else {
			return false
		}

		return true
	}

	proc queue_proxy { url } {
		variable proxy
		if { $proxy ne {} } { return [split $proxy {:}] }		
		return [list]
	}
	
	proc queue_done { token } {
		upvar #0 $token state
		variable reqqueue
		variable maxredir

#		lput putlog "$token"
		
		set errid  		[::http::status $token]
		set errstr 		[::http::error  $token]
		
		set	id  	[array  names reqqueue "$token,*"]
		foreach { parser extra redir } $reqqueue($id) { break }
		regsub -- "^$token," $id {} id
	
		while (1) {
			if { $errid == "ok" && [::http::ncode $token] == 302 } {
				if { $redir < $maxredir } {			
					array set meta $state(meta)
					if { [info exists meta(Location)] } {
						variable fetchurl
						queue_add "$fetchurl$meta(Location)" $id $parser $extra [incr redir]
						break
					}
				} else {
					set errid   "error"
					set errstr  "Maximum redirects reached"
				}
			} 
			
			if { [catch { $parser {errid} {errstr} {state(body)} {extra} } errid ] } {
				lput putlog $errid "[namespace current] "
			}

			break
		}
			
		array unset reqqueue "$token,*"
		::http::cleanup $token

		return
	}

	proc queue_clear_stamps {} {

		variable laststamp
		variable timeout

		set curr [expr { [unixtime] - 2 * $timeout / 1000 }];
#		putlog "stamps: $curr"		

		foreach { id } [array names laststamp] {
			if { $laststamp($id) < $curr } {
				array unset laststamp $id;
			}
		}		

#		putlog "stamps: [array get laststamp]"

		timer 10 "[info level 0]"
	}

	proc cmdaliases { { action {bind} } } {
		foreach { bindtype } {pub msg dcc} {
			foreach { bindproc } [info vars "[namespace current]::${bindtype}:*"] {
				variable "${bindtype}prefix"
				variable "${bindtype}flag"			
				foreach { alias } [set $bindproc] {
#					putlog "$action $bindtype [set ${bindtype}flag] [set ${bindtype}prefix]$alias $bindproc"
					catch { $action $bindtype [set ${bindtype}flag] [set ${bindtype}prefix]$alias $bindproc }
				}				
			}
		}
		
		return
	}
	
	[namespace current]::queue_clear_stamps
	cmdaliases
	putlog "[namespace current] v$version \[$date\] by $author loaded."
}


